local RayUI, E, L, V, P, G = unpack(select(2, ...))

local IsAddOnLoaded = IsAddOnLoaded
local addon = 'AddOnSkins'

if IsAddOnLoaded(addon) ~= true then return end

local _G, string = _G, string

function RayUI:LoadAddOnSkinsProfile()
    --[[----------------------------------
	--	AddOnSkins - Settings
	--]] ----------------------------------
    local AS = unpack(_G.AddOnSkins)
    AS.data:SetProfile('RayUI')

    AS.db['EmbedSystemMessage'] = false
    AS.db['EmbedOoC'] = true
    AS.db['EmbedOoCDelay'] = 10
    AS.db['EmbedBelowTop'] = false
    AS.db['SkinTemplate'] = 'MerathilisUI'
    AS.db['DBMFont'] = E.Libs.LSM.DefaultMedia['font']
    AS.db['DBMFontSize'] = 12
    AS.db['DBMFontFlag'] = 'OUTLINE'
    AS.db['DBMRadarTrans'] = false
    AS.db['EmbedBackdrop'] = true
    AS.db['CropIcons'] = true
    AS.db['SkinDebug'] = false
    AS.db['LoginMsg'] = false
    AS.db['Parchment'] = false

    -- embeded settings
    if IsAddOnLoaded('Details') then
        AS.db['EmbedSystem'] = true
        AS.db['EmbedSystemDual'] = false
        AS.db['EmbedMain'] = 'Details'
        AS.db['EmbedLeft'] = ''
        AS.db['EmbedRight'] = ''
    end

    if IsAddOnLoaded('Skada') then
        AS.db['EmbedSystem'] = true
        AS.db['EmbedSystemDual'] = false
        AS.db['EmbedMain'] = 'Skada'
        AS.db['EmbedLeft'] = ''
        AS.db['EmbedRight'] = ''
    end
end

local function ElvUI_ASTable()
    E.Options.args.rayui.args.addons.args[addon] = {
        order = 1,
        type = 'execute',
        name = addon,
        desc = string.format(L['This will create and apply profile for %s'], addon),
        func = function()
            RayUI:LoadAddOnSkinsProfile()
            E:StaticPopup_Show('PRIVATE_RL')
            -- RayUI:Print(profileString..addon)
        end,
        disabled = function()
            return not IsAddOnLoaded(addon)
        end
    }
end

tinsert(RayUI.Config, ElvUI_ASTable)
