local RayUI, E, L, V, P, G = unpack(select(2, ...))

-- Profile Creation
function RayUI:NewProfile(new, profileName)
    ElvUI[1].data:SetDualSpecEnabled(false)
    if (new) then
        E.PopupDialogs['RAYUI_CREATE_PROFILE_NEW'] = {
            text = RayUI:cOption(L['Name for the new profile']),
            button1 = OKAY,
            button2 = CANCEL,
            hasEditBox = 1,
            whileDead = 1,
            hideOnEscape = 1,
            timeout = 0,
            OnShow = function(self, data)
                self.editBox:SetAutoFocus(false)
                self.editBox.width = self.editBox:GetWidth()
                self.editBox:Width(280)
                self.editBox:AddHistoryLine('text')
                self.editBox.temptxt = data
                self.editBox:SetText(profileName)
                self.editBox:HighlightText()
                self.editBox:SetJustifyH('CENTER')
            end,
            OnHide = function(self)
                self.editBox:Width(self.editBox.width or 50)
                self.editBox.width = nil
                self.temptxt = nil
            end,
            OnAccept = function(self, data, data2)
                local text = self.editBox:GetText()
                ElvUI[1].data:SetProfile(text)
                if GetLocale() == 'zhCN' then
                    ElvUI[1].db.general.font = '聊天'
                    ElvUI[1]:UpdateFontTemplates()
                end
                PluginInstallStepComplete.message = RayUI.Title .. 'Profile Created'
                PluginInstallStepComplete:Show()
            end
        }
        E:StaticPopup_Show('RAYUI_CREATE_PROFILE_NEW')
    else
        E.PopupDialogs['RAYUI_PROFILE_OVERRIDE'] = {
            text = RayUI:cOption(L['Are you sure you want to override the current profile?']),
            button1 = YES,
            button2 = NO,
            OnAccept = function()
                PluginInstallStepComplete.message = RayUI.Title .. L['Profile Set']
                PluginInstallStepComplete:Show()
            end,
            timeout = 0,
            whileDead = true,
            hideOnEscape = true
        }
        E:StaticPopup_Show('RAYUI_PROFILE_OVERRIDE')
    end
end
