local RayUI, E, L, V, P, G = unpack(select(2, ...))
local RM = RayUI:GetModule('RayUIMisc')
local SS = RayUI:GetModule('RayUIScreenshot')

local _G = _G

local function MiscTable()
    E.Options.args.rayui.args.modules.args.misc = {
        type = 'group',
        name = E.NewSign .. L['Miscellaneous'],
        childGroups = 'tab',
        get = function(info)
            return E.db.rayui.misc[info[#info]]
        end,
        set = function(info, value)
            E.db.rayui.misc[info[#info]] = value;
            E:StaticPopup_Show('CONFIG_RL');
        end,
        args = {
            name = {order = 1, type = 'header', name = L['Miscellaneous']},
            autoRelease = {
                order = 2,
                type = 'toggle',
                name = L['Auto Release'],
                desc = L['Auto release in battleground'],
                set = function(info, value)
                    E.db.rayui.misc[info[#info]] = value;
                end
            },
            autoScreenshot = {
                order = 3,
                type = 'toggle',
                name = L['Auto Screenshot'],
                desc = L['Take screenshot when you earned an achievement or get a legendary item'],
                set = function(info, value)
                    E.db.rayui.misc[info[#info]] = value;
                    SS:Configure()
                end
            },
            auction = {order = 4, type = 'toggle', name = _G.AUCTIONS, desc = L['Shift + Right click on auction item to buyout item']},
            focuser = {order = 5, type = 'toggle', name = L['Focuser'], desc = L['Shift + Left click on unit to set focus']}
        }
    }
end

tinsert(RayUI.Config, MiscTable)
